﻿using System.Windows;
using System.Windows.Input;
using Infragistics.Controls.Menus;

namespace TestTool.CustomButtons
{
    public class CustomButtonTool : ButtonTool
    {
        public ICommand Command
        {
            get { return (ICommand)GetValue(CommandProperty); }
            set { SetValue(CommandProperty, value); }
        }
        

        public static readonly DependencyProperty CommandProperty = DependencyProperty.Register("Command", typeof(ICommand), typeof(CustomButtonTool), new PropertyMetadata(CommandChangedCallback));

        private static void CommandChangedCallback(DependencyObject d, DependencyPropertyChangedEventArgs args)
        {
            var cmd = d as CustomButtonTool;
            cmd.Command = args.NewValue as ICommand;
        }

        public object CommandParameter
        {
            get { return (object)GetValue(CommandParameterProperty); }
            set { SetValue(CommandParameterProperty, value); }
        }

        public static readonly DependencyProperty CommandParameterProperty = DependencyProperty.Register("CommandParameter", typeof(object), typeof(CustomButtonTool), null);

        protected override RibbonToolBaseControl ResolveToolControl()
        {
            return new CustomButtonToolControl(this);
        }
    }
}
