﻿using System.Windows.Input;
using Infragistics.Controls.Menus;

namespace TestTool.CustomButtons
{
    public class CustomButtonToolControl : ButtonToolControl
    {
        CustomButtonTool _customButtonTool;

        public CustomButtonToolControl(RibbonToolBase tool)
        {
            _customButtonTool = tool as CustomButtonTool;
            Tool = tool;
        }

        private void ExecuteCommand()
        {
            object commandParameter = _customButtonTool.CommandParameter;
            ICommand command = _customButtonTool.Command;
            if ((command != null) &&
                command.CanExecute(commandParameter))
            {
                command.Execute(commandParameter);
            }
        }

        protected override void RaiseToolClick()
        {
            base.RaiseToolClick();

            this.ExecuteCommand();
        }
    }
}
