﻿using System;
using System.Windows.Input;
using Infragistics.Controls.Menus;

namespace TestTool.CustomButtons
{
    public class CustomRadioButtonToolControl : RadioButtonToolControl
    {
        private readonly CustomRadioButtonTool _customRadioButtonTool;

        public CustomRadioButtonToolControl(CustomRadioButtonTool customRadioButtonTool)
        {
            if (customRadioButtonTool == null)
                throw new ArgumentNullException("customRadioButtonTool");

            _customRadioButtonTool = customRadioButtonTool;
            Tool = customRadioButtonTool;
        }

        private void ExecuteCommand(bool isChecked)
        {
            //object commandParameter = _customRadioButtonTool.CommandParameter;
            ICommand command = _customRadioButtonTool.Command;
            if ((command != null) &&
                command.CanExecute(isChecked))
            {
                command.Execute(isChecked);
            }
        }

        protected override void RaiseToolChecked()
        {
            base.RaiseToolChecked();
            ExecuteCommand(true);
        }

        protected override void RaiseToolUnchecked()
        {
            base.RaiseToolUnchecked();
            ExecuteCommand(false);
        }
    }
}
